// import {LineLayer, PointLayer, PolygonLayer, Popup} from "@antv/l7";
// import {formatStringByTemplate} from "@/utils/string";
// import {getUUID} from "@/utils/ruoyi";
import {Scene} from "@antv/l7-scene";
import type {ICameraOptions, Point} from "@antv/l7-core";

/**
 * 设置地图视角
 * @param scene
 * @param center  中心点
 * @param zoom    层级
 * @param pitch   倾斜角度
 * @param padding
 */
export function setCenter(scene: Scene, center: Point, zoom: number, pitch = 0, padding = {}) {
  if (center && zoom) {
    scene.setZoomAndCenter(zoom, center);
  } else if (center) {
    scene.setCenter(center, padding as ICameraOptions);
  } else if (zoom) {
    scene.setZoom(zoom);
  }
  scene.setPitch(pitch);
}

//
// let _scene: any;
//
// const imageMap = new Map()
//
// function getValueByConditions(data: any, conditions: any, field: any) {
//   let condition;
//   for (const item of conditions) {
//     if (compareByConditions(data, item)) {
//       condition = item
//       break
//     }
//   }
//
//   if (!condition) {
//     return null;
//   }
//
//   if (field === 'color') {
//     return condition[field]
//   }
//
//   if (condition[field] !== 'image') {
//     return condition[field]
//   }
//
//   if (condition[field] === 'image') {
//     let id;
//     if (imageMap.has(condition.imageSrc)) {
//       id = imageMap.get(condition.imageSrc)
//     } else {
//       id = getUUID()
//       imageMap.set(condition.imageSrc, id);
//       _scene.addImage(id, condition.imageSrc);
//     }
//     return id
//   }
//
//   return null;
// }
//
// function compareByConditions(data: any, condition: any) {
//   switch (condition.cond) {
//     case 'lt':
//       if (data < condition.value) {
//         return true
//       }
//       break
//     case 'lte':
//       if (data <= condition.value) {
//         return true
//       }
//       break
//     case 'eq':
//       if (data == condition.value) {
//         return true
//       }
//       break
//     case 'gt':
//       if (data > condition.value) {
//         return true
//       }
//       break
//     case 'gte':
//       if (data >= condition.value) {
//         return true
//       }
//       break
//     case 'ne':
//       if (data != condition.value) {
//         return true
//       }
//       break
//   }
//   return false;
// }
//
// /**
//  * 图层数据配置
//  * @param dataType
//  * @returns {{parser: {x: string, y: string, type: string}}|null}
//  */
// function getSourceOptions(dataType: any) {
//   switch (dataType) {
//     case 'geojson':
//       return null;
//     case 'list':
//       return {
//         parser: {
//           type: 'json',
//           x: '经度',
//           y: '纬度',
//         },
//       }
//     default:
//   }
// }
//
// /**
//  * 图层形状配置
//  * @param layer
//  * @param config
//  */
// function setLayerShape(layer: any, config: any) {
//   if (config.isConstant) {
//     let shape = config.value
//     if (config.value === 'image') {
//       let id;
//       if (imageMap.has(config.imageSrc)) {
//         id = imageMap.get(config.imageSrc)
//       } else {
//         id = getUUID()
//         imageMap.set(config.imageSrc, id);
//         _scene.addImage(id, config.imageSrc);
//       }
//       shape = id
//     }
//     layer.shape(shape)
//   } else {
//     const field = config.field
//     const conditions = config.conditions
//     layer.shape(field, (field: any) => {
//       return getValueByConditions(field, conditions, 'shape');
//     });
//   }
// }
//
// /**
//  * 图层颜色配置
//  * @param layer
//  * @param config
//  */
// function setLayerColor(layer: any, config: any) {
//   if (config.isConstant) {
//     layer.color(config.value)
//   } else {
//     const field = config.field
//     const conditions = config.conditions
//     layer.color(field, (field: any) => {
//       return getValueByConditions(field, conditions, 'color');
//     });
//   }
// }
//
// export function setMark({dataType, mapData}, config: any, scene: any) {
//   if (scene) {
//     _scene = scene
//   }
//
//   const sourceOptions = getSourceOptions(dataType)
//   if (!config.enabled) {
//     return
//   }
//   // 标注
//   const markLayer = new PointLayer({})
//     .source(mapData)
//     .shape(config.field, 'text')
//     .size(12)
//     .color('#000')
//     .style({
//       textAnchor: 'center', // 文本相对锚点的位置 center|left|right|top|bottom|top-left
//       textOffset: [0, 0], // 文本相对锚点的偏移量 [水平, 垂直]
//       spacing: 2, // 字符间距
//       padding: [1, 1], // 文本包围盒 padding [水平，垂直]，影响碰撞检测结果，避免相邻文本靠的太近
//       stroke: '#ffffff', // 描边颜色
//       strokeWidth: 2, // 描边宽度
//       strokeOpacity: 1.0,
//     });
//   _scene.addLayer(markLayer);
// }
//
// function setPopup(layer: any, config: any) {
//   if (!config.enabled) {
//     return
//   }
//   layer.on(config.trigger, (e) => {
//     let properties = e.feature.properties || e.feature
//     const content = formatStringByTemplate(properties, config.content)
//
//     // offsets: [0, 0], closeButton: false,
//     const popup = new Popup({})
//       .setLnglat(e.lngLat)
//       .setHTML(content);
//     _scene.addPopup(popup);
//   });
// }
//
// function createPointByCongfig(config: any, mapData, dataType) {
//   const sourceOptions = getSourceOptions(dataType)
//   const layer = new PointLayer({})
//     .source(mapData, sourceOptions)
//     .size(16)
//     .active(config.active);
//   setLayerShape(layer, config.shape);
//   // 颜色配置
//   setLayerColor(layer, config.color);
//   _scene.addLayer(layer);
//   setMark({dataType, mapData}, config.mark);
//   setPopup(layer, config.popup);
// }
//
// /**
//  * 创建线图层
//  * @param config 配置
//  * @param dataType 图层数据类型
//  * @param mapData 图层数据
//  */
// function createLineByCongfig(config, {dataType, mapData}) {
//   const sourceOptions = getSourceOptions(dataType)
//   const layer = new LineLayer({})
//     .source(mapData, sourceOptions)
//     .size(1)
//     .style({
//       lineType: 'dash',
//       dashArray: [2, 2],
//     })
//     .active(config.active);
//   _scene.addLayer(layer);
//   setMark({dataType, mapData}, config.mark);
//   setPopup(layer, config.popup);
// }
//
// /**
//  * 创建面图层
//  * @param config 配置
//  * @param dataType 图层数据类型
//  * @param mapData 图层数据
//  */
// function createPolygonByCongfig(config, {dataType, mapData}) {
//   const sourceOptions = getSourceOptions(dataType)
//   const layer = new PolygonLayer({})
//     .source(mapData, sourceOptions)
//     .shape('fill')
//     .active(config.active);
//   // 颜色配置
//   setLayerColor(layer, config.color);
//   _scene.addLayer(layer);
//   setMark({dataType, mapData}, config.mark);
//   setPopup(layer, config.popup);
// }
//
// function createMarkByCongfig(config, {dataType, mapData}) {
//   setMark({dataType, mapData}, config.mark)
// }
//
// /**
//  * 根据配置加载图层
//  * @param scene
//  * @param mapConfig
//  * @returns {Promise<void>}
//  */
// export async function loadMapData(scene: any, mapConfig: any) {
//   _scene = scene
//   console.log('mapConfig', mapConfig);
//   // 清空图层
//   _scene.removeAllLayer();
//   if (!mapConfig.enabled) {
//     return
//   }
//
//   const layers = mapConfig.layers
//   for (const layer of layers) {
//     if (!layer.data?.mapDataId) {
//       continue;
//     }
//
//     // 1. 加载数据
//     const mapJson:any = {}
//     console.log('mapJson', mapJson);
//     // switch (layer.type) {
//     //   case 'point':
//     //     createPointByCongfig(layer, mapJson)
//     //     break
//     //   case 'line':
//     //     createLineByCongfig(layer, mapJson)
//     //     break
//     //   case 'polygon':
//     //     createPolygonByCongfig(layer, mapJson)
//     //     break
//     //   case 'mark':
//     //     createMarkByCongfig(layer, mapJson)
//     //     break
//     // }
//   }
//
//   // 视角
//   setCenter(scene, mapConfig.center, mapConfig.zoom, mapConfig.pitch);
// }
//

//
//
// export function getLegendData(config: any) {
//   const layers = config.layers
//
//   const layerLegend = layers.reduce((acc: any, item: any) => {
//     if (item.legend && item.legend.data) {
//       return acc.concat(item.legend.data);
//     } else {
//       return acc;
//     }
//   }, []);
//
//   return layerLegend.map((item: any) => {
//     const data = {label: item.text}
//     if (item.shape === 'image') {
//       data.imgType = 'img'
//       data.src = item.imgSrc
//     } else {
//       data.imgType = 'svg'
//       data.src = item.shape
//       data.imgStyle = {fill: item.color}
//     }
//     return data
//   })
// }
